diff --git a/wcs/qommon/logger.py b/wcs/qommon/logger.py
index c0ccd70af..2b38f52fb 100644
--- a/wcs/qommon/logger.py
+++ b/wcs/qommon/logger.py
@@ -17,8 +17,6 @@
 import logging
 import os
 
-from django.utils import six
-
 from quixote import get_publisher, get_session, get_request
 from quixote.logger import DefaultLogger
 
@@ -78,7 +76,7 @@ class Formatter(logging.Formatter):
 
             user = request.user
             if user:
-                if isinstance(user, six.string_types + six.integer_types):
+                if isinstance(user, (str, int)):
                     user_id = user
                 else:
                     user_id = user.id
diff --git a/wcs/qommon/misc.py b/wcs/qommon/misc.py
index e4e2b6ff7..ec59ee902 100644
--- a/wcs/qommon/misc.py
+++ b/wcs/qommon/misc.py
@@ -18,9 +18,11 @@ import datetime
 import decimal
 import calendar
 import html
+import io
 import re
 import os
 import time
+import urllib.parse
 import base64
 import json
 import subprocess
@@ -37,13 +39,10 @@ except ImportError:
 
 from django.conf import settings
 from django.utils import datetime_safe
-from django.utils import six
 from django.utils.encoding import force_text
 from django.utils.formats import localize
 from django.utils.html import strip_tags
 from django.template import TemplateSyntaxError, VariableDoesNotExist
-from django.utils.six.moves.urllib.parse import quote, urlencode
-from django.utils.six.moves.urllib import parse as urlparse
 from django.utils.text import Truncator
 
 from quixote import get_publisher, get_response, get_request, redirect
@@ -54,8 +53,6 @@ from . import get_cfg, get_logger, ezt
 from .errors import ConnectionError, RequestError
 from .template import Template
 
-from django.utils.six import BytesIO, StringIO
-
 try:
     subprocess.check_call(['which', 'pdftoppm'], stdout=subprocess.DEVNULL)
     HAS_PDFTOPPM = True
@@ -167,7 +164,7 @@ def get_provider_key(provider_id):
 def simplify(s, space='-'):
     if s is None:
         return ''
-    if not isinstance(s, six.text_type):
+    if not isinstance(s, str):
         if get_publisher() and get_publisher().site_charset:
             s = force_text('%s' % s, get_publisher().site_charset, errors='ignore')
         else:
@@ -269,7 +266,7 @@ def site_encode(s):
         return None
     if isinstance(s, str):
         return s
-    if not isinstance(s, six.string_types):
+    if not isinstance(s, str):
         s = force_text(s)
     return s.encode(get_publisher().site_charset)
 
@@ -346,7 +343,7 @@ def _http_request(
 ):
     get_publisher().reload_cfg()
 
-    splitted_url = urlparse.urlsplit(url)
+    splitted_url = urllib.parse.urlsplit(url)
     if splitted_url.scheme not in ('http', 'https'):
         raise ConnectionError('invalid scheme in URL %s' % url)
 
@@ -391,7 +388,7 @@ def urlopen(url, data=None):
     response, status, data, auth_header = _http_request(
         url, 'GET' if data is None else 'POST', body=data, raise_on_http_errors=True
     )
-    return BytesIO(data)
+    return io.BytesIO(data)
 
 
 def http_get_page(url, **kwargs):
@@ -418,14 +415,14 @@ def get_variadic_url(url, variables, encode_query=True):
     if '{{' in url or '{%' in url:
         try:
             url = Template(url).render(variables)
-            p = urlparse.urlsplit(url)
+            p = urllib.parse.urlsplit(url)
             scheme, netloc, path, query, fragment = (p.scheme, p.netloc, p.path, p.query, p.fragment)
             if path.startswith('//'):
                 # don't let double slash happen at the root of the URL, this
                 # happens when a template such as {{url}}/path is used (with
                 # {{url}} already ending with a slash).
                 path = path[1:]
-            return urlparse.urlunsplit((scheme, netloc, path, query, fragment))
+            return urllib.parse.urlunsplit((scheme, netloc, path, query, fragment))
         except (TemplateSyntaxError, VariableDoesNotExist):
             return url
 
@@ -433,16 +430,16 @@ def get_variadic_url(url, variables, encode_query=True):
     def ezt_substitute(template, variables):
         tmpl = ezt.Template()
         tmpl.parse(template)
-        fd = StringIO()
+        fd = io.StringIO()
         tmpl.generate(fd, variables)
         return fd.getvalue()
 
     def partial_quote(string):
         # unquote brackets, as there may be further processing that needs them
         # intact.
-        return quote(string).replace('%5B', '[').replace('%5D', ']')
+        return urllib.parse.quote(string).replace('%5B', '[').replace('%5D', ']')
 
-    p = urlparse.urlsplit(url)
+    p = urllib.parse.urlsplit(url)
     scheme, netloc, path, query, fragment = p.scheme, p.netloc, p.path, p.query, p.fragment
     if netloc and '[' in netloc:
         netloc = ezt_substitute(netloc, variables)
@@ -456,7 +453,7 @@ def get_variadic_url(url, variables, encode_query=True):
                 # there were no / in the original path (the two / comes from
                 # the scheme/netloc separation, this means there is no path)
                 before_path = ezt_substitute(path, variables)
-                p2 = urlparse.urlsplit(before_path)
+                p2 = urllib.parse.urlsplit(before_path)
                 scheme, netloc, path = p2.scheme, p2.netloc, p2.path
             else:
                 # there is a path, we need to get back to the original URL and
@@ -467,7 +464,7 @@ def get_variadic_url(url, variables, encode_query=True):
                 else:
                     before_path, path = path, ''
                 before_path = ezt_substitute(before_path, variables)
-                p2 = urlparse.urlsplit(before_path)
+                p2 = urllib.parse.urlsplit(before_path)
                 scheme, netloc = p2.scheme, p2.netloc
                 if p2.path:
                     if not path:
@@ -487,7 +484,7 @@ def get_variadic_url(url, variables, encode_query=True):
     if fragment and '[' in fragment:
         fragment = partial_quote(ezt_substitute(fragment, variables))
     if query and '[' in query:
-        p_qs = urlparse.parse_qsl(query)
+        p_qs = urllib.parse.parse_qsl(query)
         if len(p_qs) == 0:
             # this happened because the query string has no key/values,
             # probably because it's a single substitution variable (ex:
@@ -502,10 +499,10 @@ def get_variadic_url(url, variables, encode_query=True):
                     v = ezt_substitute(v, variables)
                 query.append((k, v))
             if encode_query:
-                query = urlencode(query)
+                query = urllib.parse.urlencode(query)
             else:
                 query = '&'.join('%s=%s' % (k, v) for (k, v) in query)
-    return urlparse.urlunsplit((scheme, netloc, path, query, fragment))
+    return urllib.parse.urlunsplit((scheme, netloc, path, query, fragment))
 
 
 def get_foreground_colour(background_colour):
@@ -662,7 +659,7 @@ def get_thumbnail(filepath, content_type=None):
 
     if content_type == 'application/pdf':
         try:
-            fp = BytesIO(
+            fp = io.BytesIO(
                 subprocess.check_output(
                     ['pdftoppm', '-png', '-scale-to-x', '500', '-scale-to-y', '-1', filepath]
                 )
@@ -705,7 +702,7 @@ def get_thumbnail(filepath, content_type=None):
             # * File "PIL/PngImagePlugin.py", line 119, in read
             # * raise SyntaxError("broken PNG file (chunk %s)" % repr(cid))
             raise IOError
-        image_thumb_fp = BytesIO()
+        image_thumb_fp = io.BytesIO()
         image.save(image_thumb_fp, "PNG")
     except IOError:
         # failed to create thumbnail.
diff --git a/wcs/qommon/publisher.py b/wcs/qommon/publisher.py
index 8ab133ecb..86e84954b 100644
--- a/wcs/qommon/publisher.py
+++ b/wcs/qommon/publisher.py
@@ -18,14 +18,15 @@ from __future__ import print_function
 
 import codecs
 import collections
-from django.utils.six.moves import builtins
-from django.utils.six.moves import configparser as ConfigParser
-from django.utils.six.moves import cPickle
-from django.utils.six.moves.urllib import parse as urllib
+import builtins
+import configparser
+import pickle
+import urllib.parse
 import datetime
 from decimal import Decimal
 import importlib
 import inspect
+import io
 import os
 import fcntl
 import hashlib
@@ -43,10 +44,8 @@ import xml.etree.ElementTree as ET
 
 from django.conf import settings
 from django.http import Http404
-from django.utils import six
 from django.utils import translation
 from django.utils.encoding import force_text, force_bytes
-from django.utils.six import StringIO
 
 from quixote.publish import Publisher, get_request, get_response, get_publisher, redirect
 from .http_request import HTTPRequest
@@ -128,7 +127,7 @@ class QommonPublisher(Publisher, object):
                 return '%s://%s%s' % (
                     req.get_scheme(),
                     req.get_server(),
-                    urllib.quote(req.environ.get('SCRIPT_NAME')),
+                    urllib.parse.quote(req.environ.get('SCRIPT_NAME')),
                 )
         return 'https://%s' % os.path.basename(get_publisher().app_dir)
 
@@ -141,7 +140,7 @@ class QommonPublisher(Publisher, object):
             return '%s://%s%s/backoffice' % (
                 req.get_scheme(),
                 req.get_server(),
-                urllib.quote(req.environ.get('SCRIPT_NAME')),
+                urllib.parse.quote(req.environ.get('SCRIPT_NAME')),
             )
         return 'https://%s/backoffice' % os.path.basename(self.app_dir)
 
@@ -206,7 +205,7 @@ class QommonPublisher(Publisher, object):
                 self, request, original_response, exc_type, exc_value, tb
             )
 
-        error_file = StringIO()
+        error_file = io.StringIO()
 
         if limit is None:
             if hasattr(sys, 'tracebacklimit'):
@@ -356,7 +355,7 @@ class QommonPublisher(Publisher, object):
         self.ngettext = translation.ngettext
 
     def load_site_options(self):
-        self.site_options = ConfigParser.ConfigParser()
+        self.site_options = configparser.ConfigParser()
         site_options_filename = os.path.join(self.app_dir, 'site-options.cfg')
         if not os.path.exists(site_options_filename):
             return
@@ -378,9 +377,9 @@ class QommonPublisher(Publisher, object):
             self.load_site_options()
         try:
             return self.site_options.get('options', option) == 'true'
-        except ConfigParser.NoSectionError:
+        except configparser.NoSectionError:
             return defaults.get(option, False)
-        except ConfigParser.NoOptionError:
+        except configparser.NoOptionError:
             return defaults.get(option, False)
 
     def get_site_option(self, option, section='options'):
@@ -394,9 +393,9 @@ class QommonPublisher(Publisher, object):
             self.load_site_options()
         try:
             return self.site_options.get(section, option)
-        except ConfigParser.NoSectionError:
+        except configparser.NoSectionError:
             return defaults.get(section, {}).get(option)
-        except ConfigParser.NoOptionError:
+        except configparser.NoOptionError:
             return defaults.get(section, {}).get(option)
 
     def get_site_storages(self):
@@ -712,7 +711,7 @@ class QommonPublisher(Publisher, object):
     cfg = None
 
     def write_cfg(self):
-        s = cPickle.dumps(self.cfg, protocol=2)
+        s = pickle.dumps(self.cfg, protocol=2)
         filename = os.path.join(self.app_dir, 'config.pck')
         storage.atomic_write(filename, s)
 
@@ -720,7 +719,7 @@ class QommonPublisher(Publisher, object):
         filename = os.path.join(self.app_dir, 'config.pck')
         try:
             with open(filename, 'rb') as fd:
-                self.cfg = cPickle.load(fd, encoding='utf-8')
+                self.cfg = pickle.load(fd, encoding='utf-8')
         except:
             self.cfg = {}
 
@@ -908,26 +907,26 @@ class QommonPublisher(Publisher, object):
             self.load_site_options()
         try:
             d.update(dict(self.site_options.items('variables', raw=True)))
-        except ConfigParser.NoSectionError:
+        except configparser.NoSectionError:
             pass
         d['manager_homepage_url'] = d.get('portal_agent_url')
         d['manager_homepage_title'] = d.get('portal_agent_title')
         return d
 
     def is_relatable_url(self, url):
-        parsed_url = urllib.urlparse(url)
+        parsed_url = urllib.parse.urlparse(url)
         if not parsed_url.netloc:
             return True
-        if parsed_url.netloc == urllib.urlparse(self.get_frontoffice_url()).netloc:
+        if parsed_url.netloc == urllib.parse.urlparse(self.get_frontoffice_url()).netloc:
             return True
-        if parsed_url.netloc == urllib.urlparse(self.get_backoffice_url()).netloc:
+        if parsed_url.netloc == urllib.parse.urlparse(self.get_backoffice_url()).netloc:
             return True
         if parsed_url.netloc in [x.strip() for x in self.get_site_option('relatable-hosts').split(',')]:
             return True
         try:
             if parsed_url.netloc in self.site_options.options('api-secrets'):
                 return True
-        except ConfigParser.NoSectionError:
+        except configparser.NoSectionError:
             pass
         return False
 
diff --git a/wcs/qommon/saml2.py b/wcs/qommon/saml2.py
index 23972c3ea..75cd5e5b7 100644
--- a/wcs/qommon/saml2.py
+++ b/wcs/qommon/saml2.py
@@ -25,7 +25,7 @@ except ImportError:
     lasso = None
 
 from django.utils.encoding import force_text
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 
 from quixote import get_request, get_response, redirect, get_field, get_publisher
 from quixote.http_request import parse_header
@@ -186,11 +186,11 @@ class Saml2Directory(Directory):
             login.msgRelayState = get_request().form.get('next')
 
         next_url = login.msgRelayState or get_publisher().get_frontoffice_url()
-        parsed_url = urlparse.urlparse(next_url)
+        parsed_url = urllib.parse.urlparse(next_url)
         request = get_request()
         scheme = parsed_url.scheme or request.get_scheme()
         netloc = parsed_url.netloc or request.get_server()
-        next_url = urlparse.urlunsplit(
+        next_url = urllib.parse.urlunsplit(
             (scheme, netloc, parsed_url.path, parsed_url.query, parsed_url.fragment)
         )
         samlp_extensions = '''<samlp:Extensions
@@ -372,10 +372,10 @@ class Saml2Directory(Directory):
         if relay_state == 'backoffice':
             after_url = get_publisher().get_backoffice_url()
         elif relay_state:
-            parsed_url = urlparse.urlparse(relay_state)
+            parsed_url = urllib.parse.urlparse(relay_state)
             scheme = parsed_url.scheme or request.get_scheme()
             netloc = parsed_url.netloc or request.get_server()
-            after_url = urlparse.urlunsplit(
+            after_url = urllib.parse.urlunsplit(
                 (scheme, netloc, parsed_url.path, parsed_url.query, parsed_url.fragment)
             )
             if not (
diff --git a/wcs/qommon/sms.py b/wcs/qommon/sms.py
index b2ddb3b6f..eefd0cabd 100644
--- a/wcs/qommon/sms.py
+++ b/wcs/qommon/sms.py
@@ -16,7 +16,7 @@
 
 import re
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from . import N_, errors, misc
 from . import get_cfg, get_logger
diff --git a/wcs/qommon/storage.py b/wcs/qommon/storage.py
index e86826271..fb6bd63a2 100644
--- a/wcs/qommon/storage.py
+++ b/wcs/qommon/storage.py
@@ -25,10 +25,9 @@ import shutil
 import sys
 import tempfile
 
-from django.utils import six
 from django.utils.encoding import force_bytes
-from django.utils.six.moves import builtins
-from django.utils.six.moves import _thread
+import builtins
+import _thread
 
 from .vendor import locket
 
@@ -150,7 +149,7 @@ class Criteria(object):
         self.typed_none = ''
         if isinstance(self.value, bool):
             self.typed_none = False
-        elif isinstance(self.value, six.integer_types + (float,)):
+        elif isinstance(self.value, (int, float)):
             self.typed_none = -sys.maxsize
         elif isinstance(self.value, time.struct_time):
             self.typed_none = time.gmtime(-(10 ** 10))  # 1653
diff --git a/wcs/qommon/template.py b/wcs/qommon/template.py
index cd0b913e0..5d279bfbd 100644
--- a/wcs/qommon/template.py
+++ b/wcs/qommon/template.py
@@ -14,6 +14,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
+import io
 import os
 import glob
 import re
@@ -28,8 +29,6 @@ from django.template import (
 from django.template.loader import render_to_string
 from django.utils.encoding import force_text, smart_text
 from django.utils.safestring import SafeString, SafeText
-from django.utils import six
-from django.utils.six import StringIO
 
 from quixote import get_session, get_request, get_response, get_publisher
 from quixote.directory import Directory
@@ -112,7 +111,7 @@ def get_theme_dict(theme_xml):
     desc = force_str(tree.findtext('desc') or '')
     author = force_str(tree.findtext('author') or '')
     icon = None
-    if isinstance(theme_xml, six.string_types):
+    if isinstance(theme_xml, str):
         icon = os.path.join(os.path.dirname(theme_xml), 'icon.png')
         if not os.path.exists(icon):
             icon = None
@@ -412,7 +411,7 @@ def decorate(body, response):
         else:
             template = default_template
 
-    fd = StringIO()
+    fd = io.StringIO()
     vars = get_decorate_vars(body, response, generate_breadcrumb=generate_breadcrumb)
 
     template.generate(fd, vars)
@@ -527,7 +526,7 @@ class Template(object):
         return re.sub(r'[\uE000-\uF8FF]', '', rendered)
 
     def ezt_render(self, context={}):
-        fd = StringIO()
+        fd = io.StringIO()
         try:
             self.template.generate(fd, context)
         except ezt.EZTException as e:
diff --git a/wcs/qommon/templatetags/qommon.py b/wcs/qommon/templatetags/qommon.py
index fb0021b0e..f5bee1a16 100644
--- a/wcs/qommon/templatetags/qommon.py
+++ b/wcs/qommon/templatetags/qommon.py
@@ -36,7 +36,6 @@ except ImportError:
 from django import template
 from django.template import defaultfilters
 from django.utils import dateparse
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
 from django.utils.safestring import mark_safe
 from django.utils.timezone import is_naive, make_aware
@@ -222,7 +221,7 @@ def parse_decimal(value, do_raise=False):
         # treat all booleans as 0 (contrary to Python behaviour where
         # decimal(True) == 1).
         value = 0
-    if isinstance(value, six.string_types):
+    if isinstance(value, str):
         # replace , by . for French users comfort
         value = value.replace(',', '.')
     try:
@@ -505,7 +504,7 @@ def divide(term1, term2):
 def sum_(list_):
     if hasattr(list_, 'get_value'):
         list_ = list_.get_value()  # unlazy
-    if isinstance(list_, six.string_types):
+    if isinstance(list_, str):
         # do not consider string as iterable, to avoid misusage
         return ''
     try:
@@ -581,7 +580,7 @@ def get_latlon(obj):
             return float(obj['lat']), float(obj['lng'])
         except (TypeError, ValueError):
             pass
-    if isinstance(obj, six.string_types) and ';' in obj:
+    if isinstance(obj, str) and ';' in obj:
         try:
             return float(obj.split(';')[0]), float(obj.split(';')[1])
         except ValueError:
@@ -732,7 +731,7 @@ def phonenumber_fr(value, separator=' '):
 
     if hasattr(value, 'get_value'):
         value = value.get_value()  # unlazy
-    if not value or not isinstance(value, six.string_types):
+    if not value or not isinstance(value, str):
         return value
     number = value.strip()
     if not number:
@@ -767,7 +766,7 @@ def phonenumber_fr(value, separator=' '):
 def is_empty(value):
     from wcs.variables import LazyFormDefObjectsManager, LazyList
 
-    if isinstance(value, (six.string_types, list, dict)):
+    if isinstance(value, (str, list, dict)):
         return not value
     if isinstance(value, (LazyFormDefObjectsManager, LazyList)):
         return not list(value)
diff --git a/wcs/qommon/upload_storage.py b/wcs/qommon/upload_storage.py
index a8e44cd75..273aaaeeb 100644
--- a/wcs/qommon/upload_storage.py
+++ b/wcs/qommon/upload_storage.py
@@ -15,6 +15,7 @@
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
 import base64
+import io
 import os
 
 from quixote import get_publisher
@@ -22,7 +23,6 @@ from quixote.http_request import Upload
 
 from django.utils.encoding import force_text
 from django.utils.module_loading import import_string
-from django.utils.six import BytesIO
 
 from .errors import ConnectionError
 from .misc import json_loads, file_digest, can_thumbnail
@@ -51,7 +51,7 @@ class PicklableUpload(Upload):
         self.__dict__.update(dict)
         if hasattr(self, 'data'):
             # backward compatibility with older w.c.s. version
-            self.fp = BytesIO(self.data)
+            self.fp = io.BytesIO(self.data)
             del self.data
 
     def get_file(self):
diff --git a/wcs/qommon/x509utils.py b/wcs/qommon/x509utils.py
index 5f1686bdc..c37199d37 100644
--- a/wcs/qommon/x509utils.py
+++ b/wcs/qommon/x509utils.py
@@ -21,7 +21,6 @@ import os
 import subprocess
 import stat
 
-from django.utils import six
 from django.utils.encoding import force_text
 
 _openssl = 'openssl'
@@ -29,7 +28,7 @@ _openssl = 'openssl'
 
 def decapsulate_pem_file(file_or_string):
     '''Remove PEM header lines'''
-    if not isinstance(file_or_string, six.string_types):
+    if not isinstance(file_or_string, str):
         content = file_or_string.read()
     else:
         content = file_or_string
diff --git a/wcs/root.py b/wcs/root.py
index 0d4c744c0..2a62f67e3 100644
--- a/wcs/root.py
+++ b/wcs/root.py
@@ -19,7 +19,7 @@ import json
 import os
 import re
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import get_publisher, get_response, get_session, redirect, get_session_manager, get_request
 from quixote.directory import Directory
@@ -113,7 +113,7 @@ class LoginDirectory(Directory):
                 if get_publisher().ident_methods.get(method)().is_interactive():
                     login_url = '../ident/%s/login' % method
                     if get_request().form.get('next'):
-                        login_url += '?' + urllib.urlencode({'next': get_request().form.get('next')})
+                        login_url += '?' + urllib.parse.urlencode({'next': get_request().form.get('next')})
                     return redirect(login_url)
                 else:
                     try:
diff --git a/wcs/sql.py b/wcs/sql.py
index d1fa6ab71..315a73f68 100644
--- a/wcs/sql.py
+++ b/wcs/sql.py
@@ -15,6 +15,7 @@
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
 import copy
+import io
 import psycopg2
 import psycopg2.extensions
 import psycopg2.extras
@@ -28,9 +29,7 @@ try:
 except ImportError:
     import pickle
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six import BytesIO
 
 from quixote import get_publisher
 from . import qommon
@@ -84,7 +83,7 @@ SQL_TYPE_MAPPING = {
 def pickle_loads(value):
     if hasattr(value, 'tobytes'):
         value = value.tobytes()
-    obj = UnpicklerClass(BytesIO(force_bytes(value)), **PICKLE_KWARGS).load()
+    obj = UnpicklerClass(io.BytesIO(force_bytes(value)), **PICKLE_KWARGS).load()
     obj = deep_bytes2str(obj)
     return obj
 
@@ -1613,7 +1612,7 @@ class SqlMixin(object):
                     # turn {'poire': 2, 'abricot': 1, 'pomme': 3} into an array
                     value = [[force_str(x), force_str(y)] for x, y in value.items()]
                 elif sql_type == 'varchar':
-                    assert isinstance(value, six.string_types)
+                    assert isinstance(value, str)
                 elif sql_type == 'date':
                     assert type(value) is time.struct_time
                     value = datetime.datetime(value.tm_year, value.tm_mon, value.tm_mday)
@@ -2012,7 +2011,7 @@ class SqlDataMixin(SqlMixin):
             elif field.key in ('item', 'items'):
                 value = self.data.get('%s_display' % field.id)
             if value:
-                if isinstance(value, six.string_types):
+                if isinstance(value, str):
                     fts_strings.append(value)
                 elif type(value) in (tuple, list):
                     fts_strings.extend(value)
@@ -2322,7 +2321,7 @@ class SqlUser(SqlMixin, wcs.users.User):
                 elif field.key in ('item', 'items'):
                     value = self.form_data.get('%s_display' % field.id)
                 if value:
-                    if isinstance(value, six.string_types):
+                    if isinstance(value, str):
                         fts_strings.append(value)
                     elif type(value) in (tuple, list):
                         fts_strings.extend(value)
diff --git a/wcs/wf/attachment.py b/wcs/wf/attachment.py
index 0c2d9d70e..4dcefb416 100644
--- a/wcs/wf/attachment.py
+++ b/wcs/wf/attachment.py
@@ -16,7 +16,7 @@
 
 import xml.etree.ElementTree as ET
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 from quixote import redirect
 
 from ..qommon import _, N_
@@ -39,7 +39,7 @@ def lookup_wf_attachment(self, filename):
     else:
         file_reference = None
 
-    filenames = [filename, urllib.unquote(filename)]
+    filenames = [filename, urllib.parse.unquote(filename)]
     for p in self.formdata.iter_evolution_parts():
         if not isinstance(p, AttachmentEvolutionPart):
             continue
@@ -69,7 +69,7 @@ def form_attachment(self):
                         % (
                             self.filled.get_url(backoffice=is_in_backoffice),
                             fn,
-                            urllib.quote(p.base_filename),
+                            urllib.parse.quote(p.base_filename),
                         )
                     )
 
diff --git a/wcs/wf/export_to_model.py b/wcs/wf/export_to_model.py
index 5418dee81..8dedce57a 100644
--- a/wcs/wf/export_to_model.py
+++ b/wcs/wf/export_to_model.py
@@ -16,6 +16,7 @@
 
 import base64
 import collections
+import io
 from xml.etree import ElementTree as ET
 import zipfile
 import os
@@ -25,9 +26,7 @@ import tempfile
 import time
 import shutil
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six import BytesIO, StringIO
 
 from quixote import get_response, get_request, get_publisher
 from quixote.directory import Directory
@@ -503,7 +502,7 @@ class ExportToModel(WorkflowStatusItem):
         try:
             # force ezt_only=True because an RTF file may contain {{ characters
             # and would be seen as a Django template
-            return BytesIO(
+            return io.BytesIO(
                 force_bytes(
                     template_on_formdata(
                         formdata,
@@ -629,7 +628,7 @@ class ExportToModel(WorkflowStatusItem):
                         node.append(child)
                     node.tail = current_tail
 
-        outstream = BytesIO()
+        outstream = io.BytesIO()
         transform_opendocument(self.model_file.get_file(), outstream, process_root)
         outstream.seek(0)
         return outstream
@@ -721,7 +720,7 @@ class ExportToModel(WorkflowStatusItem):
         filename = 'export_to_model-%s-%s-%s.upload' % ids
 
         upload = Upload(base_filename, content_type)
-        upload.fp = BytesIO()
+        upload.fp = io.BytesIO()
         upload.fp.write(content)
         upload.fp.seek(0)
         self.model_file = UploadedFile('models', filename, upload)
diff --git a/wcs/wf/geolocate.py b/wcs/wf/geolocate.py
index 50484ded4..c5ec79c69 100644
--- a/wcs/wf/geolocate.py
+++ b/wcs/wf/geolocate.py
@@ -24,7 +24,7 @@ try:
 except ImportError:
     Image = None
 
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 from quixote import get_publisher
 
 from ..qommon import _, N_, force_str
@@ -153,7 +153,7 @@ class GeolocateWorkflowStatusItem(WorkflowStatusItem):
             url += '&'
         else:
             url += '?'
-        url += 'q=%s' % urlparse.quote(address)
+        url += 'q=%s' % urllib.parse.quote(address)
         url += '&format=json'
         url += '&accept-language=%s' % (get_publisher().get_site_language() or 'en')
 
diff --git a/wcs/wf/jump.py b/wcs/wf/jump.py
index 06db24bf2..d0912bba4 100644
--- a/wcs/wf/jump.py
+++ b/wcs/wf/jump.py
@@ -19,8 +19,6 @@ import json
 import os
 import time
 
-from django.utils import six
-
 from quixote import get_publisher, get_request, redirect
 
 from quixote.directory import Directory
@@ -136,7 +134,7 @@ class JumpWorkflowStatusItem(WorkflowStatusJumpItem):
 
     def migrate(self):
         changed = super(JumpWorkflowStatusItem, self).migrate()
-        if isinstance(self.condition, six.string_types):
+        if isinstance(self.condition, str):
             if self.condition:
                 self.condition = {'type': 'python', 'value': self.condition}
             else:
diff --git a/wcs/wf/profile.py b/wcs/wf/profile.py
index d8f79af04..fc1ff8d50 100644
--- a/wcs/wf/profile.py
+++ b/wcs/wf/profile.py
@@ -20,7 +20,7 @@ import sys
 import time
 import xml.etree.ElementTree as ET
 
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 from quixote import get_publisher, get_response, get_request
 
 from ..qommon import _, N_
@@ -37,7 +37,7 @@ def user_ws_url(user_uuid):
     idps = get_cfg('idp', {})
     entity_id = list(idps.values())[0]['metadata_url']
     base_url = entity_id.split('idp/saml2/metadata')[0]
-    url = urlparse.urljoin(base_url, '/api/users/%s/' % user_uuid)
+    url = urllib.parse.urljoin(base_url, '/api/users/%s/' % user_uuid)
     secret, orig = get_secret_and_orig(url)
     url += '?orig=%s' % orig
     return sign_url(url, secret)
diff --git a/wcs/wf/roles.py b/wcs/wf/roles.py
index 3040d3cd4..be5c33b11 100644
--- a/wcs/wf/roles.py
+++ b/wcs/wf/roles.py
@@ -14,11 +14,9 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
+import urllib.parse
 import sys
 
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
-
 from quixote import get_request, get_publisher, get_response
 
 from ..qommon import _, N_
@@ -35,8 +33,8 @@ def roles_ws_url(role_uuid, user_uuid):
     idps = get_cfg('idp', {})
     entity_id = list(idps.values())[0]['metadata_url']
     base_url = entity_id.split('idp/saml2/metadata')[0]
-    url = urlparse.urljoin(
-        base_url, '/api/roles/%s/members/%s/' % (urllib.quote(role_uuid), urllib.quote(user_uuid))
+    url = urllib.parse.urljoin(
+        base_url, '/api/roles/%s/members/%s/' % (urllib.parse.quote(role_uuid), urllib.parse.quote(user_uuid))
     )
     return url
 
